unit EasyXMLU;

interface

uses
  ShellAPI,Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  janXMLparser2, ComCtrls, StdCtrls, ExtCtrls, ToolWin, Menus,
  inifiles, janStrings, janMruMenu;

type
  TEasyXMLF = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    StatusBar1: TStatusBar;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Open1: TMenuItem;
    treepop: TPopupMenu;
    AddChild1: TMenuItem;
    Delete1: TMenuItem;
    New1: TMenuItem;
    Save1: TMenuItem;
    SaveAs1: TMenuItem;
    Close1: TMenuItem;
    viewpop: TPopupMenu;
    Addattribute1: TMenuItem;
    Deleteattribute1: TMenuItem;
    N2: TMenuItem;
    Rename1: TMenuItem;
    Duplicate1: TMenuItem;
    N3: TMenuItem;
    Listby1: TMenuItem;
    selpop: TPopupMenu;
    Listbytag1: TMenuItem;
    View1: TMenuItem;
    ListNode1: TMenuItem;
    ListSubnodes1: TMenuItem;
    OpenDialog2: TOpenDialog;
    Tools1: TMenuItem;
    RunQuery1: TMenuItem;
    Panel1: TPanel;
    Splitter2: TSplitter;
    editor: TRichEdit;
    view: TListView;
    selection: TListView;
    GroupBox1: TGroupBox;
    edfilter: TMemo;
    Splitter3: TSplitter;
    Help1: TMenuItem;
    Contents1: TMenuItem;
    About1: TMenuItem;
    Select1: TMenuItem;
    Samples1: TMenuItem;
    N4: TMenuItem;
    LoadSamples1: TMenuItem;
    Splitter4: TSplitter;
    N5: TMenuItem;
    ExpandAll1: TMenuItem;
    CollapseAll1: TMenuItem;
    tree: TTreeView;
    InEdit: TEdit;
    Splitter1: TSplitter;
    N1: TMenuItem;
    TransformUsing1: TMenuItem;
    janMruMenu1: TjanMruMenu;
    TransformTo1: TMenuItem;
    Options1: TMenuItem;
    ShowMessages1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure AddChild1Click(Sender: TObject);
    procedure editorChange(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure Addattribute1Click(Sender: TObject);
    procedure Deleteattribute1Click(Sender: TObject);
    procedure ChangeName1Click(Sender: TObject);
    procedure Changevalue1Click(Sender: TObject);
    procedure treeDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure treeDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure Rename1Click(Sender: TObject);
    procedure cmdpathclick(Sender: TObject);
    procedure selectionClick(Sender: TObject);
    procedure selectionChange(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure Duplicate1Click(Sender: TObject);
    procedure Listby1Click(Sender: TObject);
    procedure Listbytag1Click(Sender: TObject);
    procedure cmdnodesclick(Sender: TObject);
    procedure ListSubnodes1Click(Sender: TObject);
    procedure ListNode1Click(Sender: TObject);
    procedure Contents1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Select1Click(Sender: TObject);
    procedure LoadSamples1Click(Sender: TObject);
    procedure ExpandAll1Click(Sender: TObject);
    procedure CollapseAll1Click(Sender: TObject);
    procedure DoShowHint(var HintStr: string; var CanShow: Boolean; var HintInfo: THintInfo);
    procedure viewEdited(Sender: TObject; Item: TListItem; var S: String);
    procedure viewClick(Sender: TObject);
    procedure InEditKeyPress(Sender: TObject; var Key: Char);
    procedure InEditExit(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure treeEdited(Sender: TObject; Node: TTreeNode; var S: String);
    procedure Broadcast1BroadcastMsg(inText: String; inData: Double;
      inKey: Integer);
    procedure TransformUsing1Click(Sender: TObject);
    procedure janMruMenu1SelectFile(Sender: TObject; FileName: String);
    procedure TransformTo1Click(Sender: TObject);
    procedure ShowMessages1Click(Sender: TObject);
  private
    { Private declarations }
    procedure open_(filename:string);
    procedure close_;
    procedure parsetree;
    procedure setcap;
    procedure parsetreenode(node: TTreeNode; dnode: TjanXMLNode2);
    procedure viewclear;
    procedure treeclear;
    procedure editorclear;
    function  getdomnode(var listitem:Tlistitem):TjanXMLNode2;
    procedure ListFolder(node: TTreeNode);
    procedure ListNode(node: TTreeNode);
    procedure ListByAttribute(attname: string);
    procedure ListByTag;
    procedure setSampleMenu;
    procedure runsampleClick(Sender: TObject);
    procedure LoadSettings;
    procedure SaveSettings;
    procedure Transform(xslfile,htmlfile:string);
    function getinitdir: string;
  public
    { Public declarations }
  end;

var
  EasyXMLF: TEasyXMLF;
  appldir:string;
  thecaption:string;
  thefile:string;
  dom:TjanXMLParser2;
  xsl:TjanXMLParser2;
implementation

{$R *.DFM}

const
  cr = chr(13)+chr(10);
  tab = chr(9);
var
  gen:TStringList;
  samples:string;


procedure Launch(Afile: string);
var command,params,workdir:string;
begin
command:=afile;
params:=#0;
workdir:=#0;
shellexecute(application.handle,'open',@command[1],
  @params[1],@workdir[1], SW_SHOWNORMAL);
end;


function GetSection(atext,asection:string):string;
var
  p1,p2:integer;
begin
  result:='';
  p1:=postext('['+asection+']',atext);
  if p1=0 then exit;
  p1:=p1+length('['+asection+']');
  p2:=posstr('[',atext,p1);
  if p2=0 then
    result:=trim(copy(atext,p1,maxint))
  else
    result:=trim(copy(atext,p1,p2-p1));
end;

procedure TEasyXMLF.FormCreate(Sender: TObject);
begin
  appldir:=extractfiledir(application.exename);
//  dateseparator:='-';
//  shortdateformat:='d/m/yyyy';

  thecaption:=caption;
  dom:=TjanXMLparser2.Create;
  xsl:=TjanXMLparser2.Create;
  gen:=TStringList.create;
  setsamplemenu;
  application.OnShowHint:=DoShowHint;
  LoadSettings;
end;

procedure TEasyXMLF.LoadSettings;
var
  ini:TInifile;
  tmp:string;
begin
  ini:=Tinifile.Create(changefileext(application.exename,'.ini'));
  tmp:=ini.ReadString('settings','dateseparator','-');
  dateseparator:=tmp[1];
  shortdateformat:=ini.ReadString('settings','shortdateformat','dd/mm/yyyy');
  ini.free;
end;

procedure TEasyXMLF.SaveSettings;
var
  ini:TInifile;
begin
  ini:=Tinifile.Create(changefileext(application.exename,'.ini'));
  ini.free;
end;

procedure TEasyXMLF.setSampleMenu;
var
  i,c:integer;
  tmp:string;
  mnu:TMenuItem;
begin
  if fileexists(appldir+'\samples.txt') then
    samples:=loadstring(appldir+'\samples.txt');
  if samples='' then exit;
  samples1.Clear;
  ListSections(samples,gen);
  c:=gen.count;
  if c=0 then exit;
  for i:=0 to c-1 do begin
    mnu:=TmenuItem.Create(self);
    mnu.caption:=gen[i];
    mnu.OnClick:=runsampleClick;
    samples1.add(mnu);
  end;
end;

procedure TEasyXMLF.runsampleClick(Sender: TObject);
var
  tmp:string;
begin
  tmp:=getSection(samples,TmenuItem(sender).caption);
  edfilter.text:=stringreplace(tmp,'{appldir}',appldir,[rfignorecase]);
end;


procedure TEasyXMLF.Open1Click(Sender: TObject);
var
  fn:string;
begin
  if thefile<>'' then
    if confirm('Do you want to save the current document?') then
      dom.SaveXML(thefile);
  close_;
  with opendialog1 do begin
    Title:='Open XML file';
    InitialDir:=getinitdir;
    Filter:='XML Files (*.xml;*.xsl)|*.xml;*.xsl';
    if not Execute then exit;
    fn:=opendialog1.filename;
  end;
  janMruMenu1.AddFile(fn);
  open_(fn);
end;

procedure TEasyXMLF.open_(filename: string);
begin
  thefile:=filename;
  dom.LoadXML(thefile);
  tree.items.BeginUpdate;
  tree.items.clear;
  parsetree;
  tree.items.EndUpdate;
  setcap;
end;

procedure TEasyXMLF.close_;
begin
  thefile:='';
  treeclear;
  editorclear;
  viewclear;
  setcap;
end;

procedure TEasyXMLF.setcap;
begin
  if thefile='' then
    caption:=thecaption
  else
    caption:=extractfilename(thefile)+' - '+thecaption;
end;

procedure TEasyXMLF.parsetreenode(node:TTreeNode;dnode:TjanXMLNode2);
var
  n,n2:TTreenode;
//  n,n2:TELTreeItem;
  dn,dn2:TjanXMLNode2;
  i,c:integer;
  nodename:string;
begin
  c:=dnode.nodes.Count;
  if c=0 then exit;
  for i:=0 to c-1 do begin
    dn2:=TjanXMLNode2(dnode.Nodes[i]);
    nodename:=dn2.name;
    n2:=tree.items.AddChild(node,nodename);
    n2.data:=dn2;
//    n2:=tree.items.AddChildObject(node,nodename,dn2);
//    n2.Hint:=nodename;
    parsetreenode(n2,dn2);
  end;
end;

procedure TEasyXMLF.parsetree;
var
  n,n2:TTreeNode;
  dn,dn2:TjanXMLNode2;
  nodename:string;
begin
  dn:=dom;
  nodename:=dn.name;
  n:=tree.Items.AddObject(nil,nodename,dn);
//  n.data:=dn;
  parsetreenode(n,dn);
end;

procedure TEasyXMLF.FormDestroy(Sender: TObject);
begin
  dom.free;
  xsl.free;
  gen.free;
end;

procedure TEasyXMLF.ListFolder(node:TTreeNode);
var
  s:string;
  i,c:integer;
  n:TTreeNode;
  dn:TjanXMLNode2;
  itm:TListitem;
begin
  c:=node.Count;
  selection.items.BeginUpdate;
  selection.items.clear;
  if c=0 then begin
    dn:=TjanXMLNode2(node.data);
    itm:=selection.items.Add;
    itm.caption:=dn.name;
    itm.SubItems.Append(dn.text);
    itm.Data:=dn;
  end
  else
  for i:=0 to c-1 do begin
    n:=node.Item[i];
    dn:=TjanXMLNode2(n.data);
    itm:=selection.items.Add;
    itm.caption:=dn.name;
    itm.SubItems.Append(dn.text);
    itm.Data:=dn;
  end;
  selection.items.EndUpdate;
end;



procedure TEasyXMLF.AddChild1Click(Sender: TObject);
var
  n,n2:TTreeNode;
  dn,dn2:TjanXMLNode2;
  nodename:string;
begin
  n:=tree.Selected;
  if n=nil then exit;
  dn:=TjanXMLNode2(n.data);
  if not inputquery('Nodes','Enter node name:',nodename) then exit;
  if nodename='' then exit;
  n2:=tree.items.AddChild(n,nodename);
  dn2:=TjanXMLNode2.create;
  n2.Data:=dn2;
  dn2.name:=nodename;
  dn.addNode(dn2);
  tree.selected:=n2;
end;

procedure TEasyXMLF.editorChange(Sender: TObject);
var
  n:TTreeNode;
  itm:TlistItem;
  dn:TjanXMLNode2;
  s:string;
  inselection:boolean;
begin
  dn:=getdomnode(itm);
  if dn=nil then exit;
  dn.text:=editor.text;
  if itm<>nil then
    itm.SubItems[0]:=editor.text;
end;

procedure TEasyXMLF.Delete1Click(Sender: TObject);
var
  n,np:TTreeNode;
  dn,dnp:TjanXMLNode2;
begin
  n:=tree.selected;
  if n=nil then exit;
  if n.AbsoluteIndex=0 then exit;
  dn:=TjanXMLNode2(n.data);
  np:=n.Parent;
  dnp:=TjanXMLNode2(np.data);
  tree.items.Delete(n);
  dnp.deleteNode(dn);
  tree.selected:=np;
end;

procedure TEasyXMLF.New1Click(Sender: TObject);
begin
  if thefile<>'' then begin
    if confirm('Do you want to save the current document?') then
      dom.SaveXML(thefile);
  end;
  close_;
  dom.xml:='<?xml version=''1.0''?>'+cr+'<root></root>';
  tree.items.BeginUpdate;
  tree.items.clear;
  parsetree;
  tree.items.EndUpdate;
end;

procedure TEasyXMLF.viewclear;
begin
  view.items.BeginUpdate;
  view.items.Clear;
  view.items.EndUpdate;
end;

procedure TEasyXMLF.editorclear;
begin
  editor.text:='';
end;

procedure TEasyXMLF.treeclear;
begin
  tree.items.BeginUpdate;
  tree.items.Clear;
  tree.items.EndUpdate;
end;

procedure TEasyXMLF.SaveAs1Click(Sender: TObject);
begin
  with savedialog1 do begin
    Title:='Save XML document';
    InitialDir:=getinitdir;
    Filter:='XML Files (*.xml;*.xsl)|*.xml;*.xsl';
    if not Execute then exit;
    thefile:=filename;
  end;
  dom.SaveXML(thefile);
  setcap;
end;

procedure TEasyXMLF.Save1Click(Sender: TObject);
begin
  if thefile<>'' then
    dom.SaveXML(thefile)
  else
    saveas1click(nil);
end;

procedure TEasyXMLF.Close1Click(Sender: TObject);
begin
  if thefile<>'' then
    if confirm('Do you want to save the current document?') then
      dom.SaveXML(thefile);
  close_;
end;

procedure TEasyXMLF.Addattribute1Click(Sender: TObject);
var
  n:TTreeNode;
  a:TjanXMLAttribute2;
  dn:TjanXMLNode2;
  s:string;
  itm:TListItem;
  index:integer;
begin
  dn:=getdomnode(itm);
  if dn=nil then exit;
  if not inputquery('Attributes','Enter attribute name:',s) then exit;
  if s='' then exit;
  if view.Items.Count=0 then begin
    dn.attribute[s]:='';
    index:=dn.indexOfAttribute(s);
    a:=TjanXMLAttribute2(dn.attributes[index]);
    itm:=view.Items.Add;
    itm.caption:=s;
    itm.SubItems.Append('');
    itm.data:=a;
    exit;
  end
  else begin
    itm:=view.FindCaption(0,s,false,true,true);
    if itm<>nil then exit;
    dn.attribute[s]:='value';
    index:=dn.indexOfAttribute(s);
    a:=TjanXMLAttribute2(dn.attributes[index]);
    itm:=view.Items.Add;
    itm.caption:=s;
    itm.SubItems.Append('value');
    itm.data:=a;
  end;
end;

procedure TEasyXMLF.Deleteattribute1Click(Sender: TObject);
var
  n:TTreeNode;
  dn:TjanXMLNode2;
  a:TjanXMLAttribute2;
  s:string;
  itm:TListItem;
begin
  dn:=getdomnode(itm);
  if dn=nil then exit;
  itm:=view.Selected;
  if itm=nil then exit;
  if messagedlg('Are you sure you want to delete '+itm.caption+'?',mtconfirmation,[mbyes,mbno],0)=mrno then exit;
  a:=TjanXMLAttribute2(itm.data);
  if dn.deleteAttribute(a) then
    view.Items.Delete(itm.Index);
end;

procedure TEasyXMLF.ChangeName1Click(Sender: TObject);
var
  a:TjanXMLAttribute2;
  oldname,newname:string;
  itm:TListItem;
begin
  itm:=view.Selected;
  if itm=nil then exit;
  oldname:=itm.caption;
  newname:=oldname;
  if not inputquery('Attributes','Change attrribute name:',newname) then exit;
  if newname='' then exit;
  if newname=oldname then exit;
  a:=TjanXMLAttribute2(itm.data);
  a.name:=newname;
  itm.caption:=newname;
end;

procedure TEasyXMLF.Changevalue1Click(Sender: TObject);
var
  a:TjanXMLAttribute2;
  dn:TjanXMLNode2;
  aname,oldvalue,newvalue:string;
  itm:TListItem;
begin
  itm:=view.Selected;
  if itm=nil then exit;
  a:=TjanXMLAttribute2(itm.data);
  oldvalue:=itm.SubItems[0];
  newvalue:=oldvalue;
  if not inputquery('Attributes','Change attrribute value:',newvalue) then exit;
  if newvalue=oldvalue then exit;
  a.value:=newvalue;
  itm.SubItems[0]:=newvalue;
end;

procedure TEasyXMLF.treeDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  accept:=source=tree;
end;

procedure TEasyXMLF.treeDragDrop(Sender, Source: TObject; X, Y: Integer);
var
  n,n2:TTreeNode;
  dn,dn2:TjanXMLNode2;
begin
  if source<>tree then exit;
  n:=tree.Selected;
  if n=nil then exit;
  if n=tree.Items[0] then exit;
//  if n.Parent=tree.items[0] then exit;
  n2:=tree.GetNodeAt(x,y);
  if n2=nil then exit;
  if n.parent=n2 then exit;
  dn:=TjanXMLNode2(n.data);
  dn2:=TjanXMLNode2(n2.data);
  if dn.moveto(dn2) then
//    n.MoveTo(n2);
    n.MoveTo(n2,naAddChild)
end;

procedure TEasyXMLF.Rename1Click(Sender: TObject);
var
  n:TTreeNode;
  dn:TjanXMLNode2;
  oldname,newname:string;
begin
  n:=tree.selected;
  if n=nil then exit;
  dn:=TjanXMLNode2(n.data);
  oldname:=n.text;
  newname:=oldname;
  if not inputquery('Node','Change nodename:',newname) then exit;
  if newname='' then exit;
  if newname=oldname then exit;
  n.Text:=newname;
  dn.name:=newname;
end;

procedure TEasyXMLF.cmdpathclick(Sender: TObject);
var
  s:string;
  i,c:integer;
  n:TTreeNode;
  dn:TjanXMLNode2;
  itm:TListitem;
  nodeList:TList;
begin
  s:=edfilter.text;
  if s='' then exit;
  s:=stringreplace(s,cr,' ',[rfreplaceall]);
  c:=tree.items.Count;
  if c=0 then exit;
  if s='*' then begin
    if tree.selected<>nil then
      listfolder(tree.selected)
    else
      listfolder(tree.items[0]);
    exit;
  end;
  n:=tree.Selected;
  if n=nil then
    n:=tree.items[0];
  dn:=TjanXMLNode2(n.data);
  nodelist:=TList.Create;
  dn.selectNodes(nodelist,s);
  selection.items.BeginUpdate;
  selection.items.clear;
  c:=nodelist.Count;
  if c<>0 then
    for i:=0 to c-1 do begin
      dn:=TjanXMLNode2(nodelist[i]);
      itm:=selection.items.Add;
      itm.caption:=dn.name;
      itm.SubItems.Append(dn.text);
      itm.Data:=dn;
    end;
  selection.items.EndUpdate;
  nodelist.Free;
end;

procedure TEasyXMLF.selectionClick(Sender: TObject);
var
  dn:TjanXMLNode2;
  a:TjanXMLattribute2;
  i,c:integer;
  itm:TListItem;
begin
  view.Items.Clear;
  itm:=selection.selected;
  if itm=nil then exit;
  dn:=TjanXMLNode2(itm.data);
  editor.text:=dn.text;
  c:=dn.attributes.Count;
  if c=0 then exit;
  for i:=0 to c-1 do begin
    a:=TjanXMLAttribute2(dn.attributes[i]);
    itm:=view.items.Add;
    itm.caption:=a.name;
    itm.SubItems.Append(a.value);
    itm.Data:=a;
  end;
end;

procedure TEasyXMLF.selectionChange(Sender: TObject; Item: TListItem;
  Change: TItemChange);
begin
  selectionclick(nil);
end;

function TEasyXMLF.getdomnode(var listitem:Tlistitem): TjanXMLNode2;
var
  n:TTreeNode;
  itm:TListItem;
begin
  result:=nil;
  listitem:=nil;
  itm:=selection.Selected;
  if itm<>nil then begin
    listitem:=itm;
    result:=TjanXMLNode2(itm.data);
  end
end;


procedure TEasyXMLF.ListNode(node:TTreeNode);
var
  n:TTreeNode;
  dn:TjanXMLNode2;
  itm:TListitem;
begin
  if node=nil then exit;
  selection.items.BeginUpdate;
  selection.items.clear;
  dn:=TjanXMLNode2(node.data);
  itm:=selection.items.Add;
  itm.caption:=dn.name;
  itm.SubItems.Append(dn.text);
  itm.Data:=dn;
  selection.items.EndUpdate;
  selection.Selected:=itm;
end;

procedure TEasyXMLF.Duplicate1Click(Sender: TObject);
var
  n,n2:TTreeNode;
  dn,dn2:TjanXMLNode2;
begin
  n:=tree.selected;
  if n=nil then exit;
  if n.AbsoluteIndex=0 then exit;
  dn:=TjanXMLNode2(n.data);
  dn2:=dn.cloneNode;
  dn.parentNode.addNode(dn2);
  n2:=tree.items.AddChild(n.parent,n.text);
  n2.Data:=dn2;
  parsetreenode(n2,dn2);
  tree.Selected:=n2;
end;

procedure TEasyXMLF.ListByAttribute(attname:string);
var
  dn:TjanXMLNode2;
  itm:TlistItem;
  i,c:integer;
begin
  if attname='' then exit;
  c:=selection.items.count;
  if c=0 then exit;
  selection.Columns[0].Caption:=attname;
  selection.items.BeginUpdate;
  for i:=0 to c-1 do begin
    itm:=selection.items[i];
    dn:=TjanXMLNode2(itm.data);
    itm.caption:=dn.attribute[attname];
  end;
  selection.items.EndUpdate;
end;


procedure TEasyXMLF.ListByTag;
var
  dn:TjanXMLNode2;
  itm:TlistItem;
  i,c:integer;
begin
  selection.Columns[0].Caption:='tag';
  c:=selection.items.count;
  if c=0 then exit;
  selection.items.BeginUpdate;
  for i:=0 to c-1 do begin
    itm:=selection.items[i];
    dn:=TjanXMLNode2(itm.data);
    itm.caption:=dn.name;
  end;
  selection.items.EndUpdate;
end;


procedure TEasyXMLF.Listby1Click(Sender: TObject);
var
  itm:TListitem;
begin
  itm:=view.Selected;
  if itm=nil then exit;
  ListByAttribute(itm.caption);
end;

procedure TEasyXMLF.Listbytag1Click(Sender: TObject);
begin
  listbytag;
end;

procedure TEasyXMLF.cmdnodesclick(Sender: TObject);
begin
  if tree.selected<>nil then
    listfolder(tree.selected);
end;

procedure TEasyXMLF.ListSubnodes1Click(Sender: TObject);
begin
  if tree.selected<>nil then
    listfolder(tree.selected);
end;

procedure TEasyXMLF.ListNode1Click(Sender: TObject);
begin
  if tree.selected<>nil then
   ListNode(tree.selected);
end;

procedure TEasyXMLF.Contents1Click(Sender: TObject);
begin
  application.HelpFile:=appldir+'\help\EasyXML.hlp';
  application.HelpJump('EasyXML');
end;

procedure TEasyXMLF.About1Click(Sender: TObject);
begin
  showmessage('EasyXML 3.0 is written by Jan Verhoeven with Delphi 5'+cr+
  'Email: jan1.verhoeven@wxs.nl'+cr+
  'URL: http://jansfreeware.com');
end;

procedure TEasyXMLF.Select1Click(Sender: TObject);
var
  dn:TjanXMLNode2;
  a:TjanXMLattribute2;
  i,c:integer;
  itm:TListItem;
begin
  itm:=selection.selected;
  if itm=nil then exit;
  dn:=TjanXMLNode2(itm.data);
  c:=tree.items.count;
  if c=0 then exit;
  for i:=0 to c-1 do begin
    if TjanXMLNode2(tree.items[i].data)=dn then begin
      tree.selected:=tree.items[i];
      exit;
    end;
  end;
end;


procedure TEasyXMLF.LoadSamples1Click(Sender: TObject);
begin
  setsamplemenu;
end;



procedure TEasyXMLF.ExpandAll1Click(Sender: TObject);
begin
  tree.FullExpand;
end;

procedure TEasyXMLF.CollapseAll1Click(Sender: TObject);
begin
  tree.FullCollapse;
end;





procedure TEasyXMLF.DoShowHint(var HintStr: string; var CanShow: Boolean;
  var HintInfo: THintInfo);
var
  n:TTreeNode;
  x,y:integer;
begin
  if hintinfo.HintControl=tree then begin
    x:=hintinfo.CursorPos.x;
    y:=hintinfo.CursorPos.y;
    n:=tree.GetNodeAt(x,y);
    if n<>nil then begin
      hintinfo.CursorRect:=n.DisplayRect(true);
      hintstr:=TjanXMLNode2(n.data).text;
    end;
  end;
end;

procedure TEasyXMLF.viewEdited(Sender: TObject; Item: TListItem;
  var S: String);
var
  a:TjanXMLAttribute2;
  oldname,newname:string;
begin
  a:=TjanXMLAttribute2(item.data);
  if s='' then
    s:=a.name;
  a.name:=s;
end;

procedure TEasyXMLF.viewClick(Sender: TObject);
var
  w,x,y:integer;
  pt:TPoint;
  item:TListItem;
  avalue:string;
begin
  InEdit.visible:=false;
  item:=view.Selected;
  if item=nil then exit;
  pt:=view.ScreenToClient(mouse.cursorpos);
  w:=view.Columns[0].Width;
  if pt.x>w then begin
    pt:=point(w,item.top);
    pt:=panel1.screentoclient(view.ClientToScreen(pt));
    avalue:=item.subitems[0];
    InEdit.text:=avalue;
    InEdit.Visible:=true;
    InEdit.BringToFront;
    InEdit.left:=pt.x;
    InEdit.top:=pt.y;
    InEdit.tag:=1;
    InEdit.SetFocus;
  end
  else begin
    pt:=point(0,item.top);
    pt:=panel1.screentoclient(view.ClientToScreen(pt));
    avalue:=item.Caption;
    InEdit.text:=avalue;
    InEdit.Visible:=true;
    InEdit.BringToFront;
    InEdit.left:=pt.x;
    InEdit.top:=pt.y;
    InEdit.tag:=0;
    InEdit.SetFocus;
  end;
end;

procedure TEasyXMLF.InEditKeyPress(Sender: TObject; var Key: Char);
var
  avalue:string;
  item:TListItem;
begin
  if key=chr(vk_return) then begin
    key:=#0;
    item:=view.selected;
    if item<>nil then begin
      if InEdit.tag=0 then begin
        TjanXMLAttribute2(item.data).name:=InEdit.text;
        item.caption:=InEdit.text;
      end
      else begin
        TjanXMLAttribute2(item.data).value:=InEdit.text;
        item.SubItems[0]:=InEdit.text;
      end;
    end;
    view.SetFocus;
  end
  else if key=chr(vk_escape) then begin
    key:=#0;
    view.SetFocus;
  end;
end;

procedure TEasyXMLF.InEditExit(Sender: TObject);
begin
  InEdit.Visible:=false;
end;

procedure TEasyXMLF.FormShow(Sender: TObject);
begin
  if paramcount>0 then begin
    thefile:=paramstr(1);
  end;
  if fileexists(thefile) then
    open_(thefile);
end;

procedure TEasyXMLF.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if thefile<>'' then
    if confirm('Do you want to save the current document?') then
      dom.SaveXML(thefile);
  savesettings;      
  close_;
end;

procedure TEasyXMLF.treeEdited(Sender: TObject; Node: TTreeNode;
  var S: String);
var
  n:TTreeNode;
  dn:TjanXMLNode2;
  oldname,newname:string;
begin
  n:=node;
  dn:=TjanXMLNode2(n.data);
  oldname:=n.text;
  newname:=s;
  if newname='' then newname:=oldname;
  s:=newname;
  if newname<>oldname then
   dn.name:=newname;
end;



procedure TEasyXMLF.Broadcast1BroadcastMsg(inText: String; inData: Double;
  inKey: Integer);
var
  fn:string;
  h:HWnd;
begin
  fn:=intext;
  if janstrings.strName(fn)='easyxml' then begin
    open_(janstrings.strValue(fn));
  end;
end;

procedure TEasyXMLF.TransformUsing1Click(Sender: TObject);
begin
  if thefile='' then exit;
  with opendialog1 do begin
    title:='Select XSLT stylesheet for transformation';
    InitialDir:=getinitdir;
    Filter:='XSL Files (*.xsl)|*.xsl';
    if not execute then exit;
  end;
  Transform(opendialog1.filename,appldir+'\xtransform.html');
end;

procedure TEasyXMLF.Transform(xslfile,htmlfile:string);
var
  tmp:string;
  t1,t2:integer;
begin
  xsl.LoadXML(xslfile);
  t1:=gettickcount;
  tmp:=dom.transformNode(xsl);
  t2:=gettickcount;
  savestring(htmlfile,tmp);
  launch(htmlfile);
  if ShowMessages1.checked then
    edfilter.text:='Performed XSLT transformation in '+inttostr(t2-t1)+' millisecond';
end;

procedure TEasyXMLF.janMruMenu1SelectFile(Sender: TObject;
  FileName: String);
begin
  if fileexists(filename) then
    open_(filename);
end;

function TEasyXMLF.getinitdir:string;
begin
  if thefile<>'' then
    result:=extractfiledir(thefile)
  else
    result:=appldir;
end;

procedure TEasyXMLF.TransformTo1Click(Sender: TObject);
var
  fnhtml:string;
  fnxsl:string;
begin
  with savedialog1 do begin
    Title:='Save Transformation To';
    Filter:='HTML files (*.html)|*.html';
    initialDir:=getinitdir;
    if not Execute then exit;
    fnhtml:=changefileext(filename,'.html');
  end;
  with opendialog1 do begin
    title:='Select XSLT stylesheet for transformation';
    InitialDir:=getinitdir;
    Filter:='XSL Files (*.xsl)|*.xsl';
    if not execute then exit;
    fnxsl:=filename;
  end;
  Transform(fnxsl,fnhtml);
end;

procedure TEasyXMLF.ShowMessages1Click(Sender: TObject);
begin
  ShowMessages1.Checked:=not ShowMessages1.checked;
end;

end.
